Index: thirdparty/blosc/blosc.c
===================================================================
--- thirdparty/blosc/blosc.c	(revision 00587dc5492d37549f9181cc536aef5fcd190667)
+++ thirdparty/blosc/blosc.c	(revision 981e22cfb30050eb24689e86ae83ab31bd8f7926)
@@ -799,130 +1483,13 @@
   _src += sizeof(int32_t)*nblocks;
 
-  /* Check that we have enough space to decompress */
-  if (nbytes > (int32_t)destsize) {
-    return -1;
-  }
-
-  /* Take global lock for the time of decompression */
-  pthread_mutex_lock(&global_comp_mutex);
-  
-  /* Populate parameters for decompression routines */
-  params.compress = 0;
-  params.clevel = 0;            /* specific for compression */
-  params.flags = (int32_t)flags;
-  params.typesize = typesize;
-  params.blocksize = blocksize;
-  params.ntbytes = 0;
-  params.nbytes = nbytes;
-  params.nblocks = nblocks;
-  params.leftover = leftover;
-  params.bstarts = bstarts;
-  params.src = (uint8_t *)src;
-  params.dest = (uint8_t *)dest;
-
-  /* Check whether this buffer is memcpy'ed */
-  if (flags & BLOSC_MEMCPYED) {
-    if (((nbytes % L1) == 0) || (nthreads > 1)) {
-      /* More effective with large buffers that are multiples of the
-       cache size or multi-cores */
-      ntbytes = do_job();
-      if (ntbytes < 0) {
-	return -1;
-      }
-    }
-    else {
-      memcpy(dest, (uint8_t *)src+BLOSC_MAX_OVERHEAD, nbytes);
-      ntbytes = nbytes;
-    }
-  }
-  else {
-    /* Do the actual decompression */
-    ntbytes = do_job();
-    if (ntbytes < 0) {
-      return -1;
-    }
-  }
-  /* Release global lock */
-  pthread_mutex_unlock(&global_comp_mutex);
-  
-  assert(ntbytes <= (int32_t)destsize);
-  return ntbytes;
-}
-
-
-/* Specific routine optimized for decompression a small number of
-   items out of a compressed chunk.  This does not use threads because
-   it would affect negatively to performance. */
-int blosc_getitem(const void *src, int start, int nitems, void *dest)
-{
-  uint8_t *_src=NULL;               /* current pos for source buffer */
-  uint8_t version, versionlz;       /* versions for compressed header */
-  uint8_t flags;                    /* flags for header */
-  int32_t ntbytes = 0;              /* the number of uncompressed bytes */
-  int32_t nblocks;                 /* number of total blocks in buffer */
-  int32_t leftover;                /* extra bytes at end of buffer */
-  int32_t *bstarts;                /* start pointers for each block */
-  uint8_t *tmp = params.tmp[0];     /* tmp for thread 0 */
-  uint8_t *tmp2 = params.tmp2[0];   /* tmp2 for thread 0 */
-  int tmp_init = 0;
-  int32_t typesize, blocksize, nbytes, ctbytes;
-  int32_t j, bsize, bsize2, leftoverblock;
-  int32_t cbytes, startb, stopb;
-  int stop = start + nitems;
-
-  _src = (uint8_t *)(src);
-
-  /* Take global lock  */
-  pthread_mutex_lock(&global_comp_mutex);
-  
-  /* Read the header block */
-  version = _src[0];                         /* blosc format version */
-  versionlz = _src[1];                       /* blosclz format version */
-  flags = _src[2];                           /* flags */
-  typesize = (int32_t)_src[3];              /* typesize */
-  _src += 4;
-  nbytes = sw32(((int32_t *)_src)[0]);      /* buffer size */
-  blocksize = sw32(((int32_t *)_src)[1]);   /* block size */
-  ctbytes = sw32(((int32_t *)_src)[2]);     /* compressed buffer size */
-
-  version += 0;                             /* shut up compiler warning */
-  versionlz += 0;                           /* shut up compiler warning */
-  ctbytes += 0;                             /* shut up compiler warning */
-
-  _src += sizeof(int32_t)*3;
-  bstarts = (int32_t *)_src;
-  /* Compute some params */
-  /* Total blocks */
-  nblocks = nbytes / blocksize;
-  leftover = nbytes % blocksize;
-  nblocks = (leftover>0)? nblocks+1: nblocks;
-  _src += sizeof(int32_t)*nblocks;
-
   /* Check region boundaries */
   if ((start < 0) || (start*typesize > nbytes)) {
     fprintf(stderr, "`start` out of bounds");
-    return (-1);
+    return -1;
   }
 
   if ((stop < 0) || (stop*typesize > nbytes)) {
     fprintf(stderr, "`start`+`nitems` out of bounds");
-    return (-1);
-  }
-
-  /* Parameters needed by blosc_d */
-  params.typesize = typesize;
-  params.flags = flags;
-
-  /* Initialize temporaries if needed */
-  if (tmp == NULL || tmp2 == NULL || current_temp.blocksize < blocksize) {
-    tmp = my_malloc(blocksize);
-    if (tmp == NULL) {
-      return -1;
-    }
-    tmp2 = my_malloc(blocksize);
-    if (tmp2 == NULL) {
-      return -1;
-    }
-    tmp_init = 1;
+    return -1;
   }
 
@@ -958,7 +1525,13 @@
     }
     else {
+      struct blosc_context context;
+      /* blosc_d only uses typesize and flags */
+      context.typesize = typesize;
+      context.header_flags = &flags;
+
       /* Regular decompression.  Put results in tmp2. */
-      cbytes = blosc_d(bsize, leftoverblock,
-                       (uint8_t *)src+sw32(bstarts[j]), tmp2, tmp, tmp2);
+      cbytes = blosc_d(&context, bsize, leftoverblock,
+                       (uint8_t *)src + sw32_(bstarts + j * 4),
+                       tmp2, tmp, tmp3);
       if (cbytes < 0) {
         ntbytes = cbytes;
@@ -971,12 +1544,6 @@
     ntbytes += cbytes;
   }
-  
-  /* Release global lock */
-  pthread_mutex_unlock(&global_comp_mutex);
-
-  if (tmp_init) {
-    my_free(tmp);
-    my_free(tmp2);
-  }
+
+  my_free(tmp);
 
   return ntbytes;
@@ -985,7 +1552,7 @@
 
 /* Decompress & unshuffle several blocks in a single thread */
-static int t_blosc(void *tids)
-{
-  int32_t tid = *(int32_t *)tids;
+static void *t_blosc(void *ctxt)
+{
+  struct thread_context* context = (struct thread_context*)ctxt;
   int32_t cbytes, ntdest;
   int32_t tblocks;              /* number of blocks per thread */
@@ -1003,44 +1570,45 @@
   int32_t nblocks;
   int32_t leftover;
-  int32_t *bstarts;
-  uint8_t *src;
+  uint8_t *bstarts;
+  const uint8_t *src;
   uint8_t *dest;
   uint8_t *tmp;
   uint8_t *tmp2;
-
-  while (1) {
-
-    init_sentinels_done = 0;     /* sentinels have to be initialised yet */
-
+  uint8_t *tmp3;
+  int rc;
+
+  while(1)
+  {
     /* Synchronization point for all threads (wait for initialization) */
-    WAIT_INIT;
-
-    /* Check if thread has been asked to return */
-    if (end_threads) {
-      return(0);
-    }
-
-    pthread_mutex_lock(&count_mutex);
-    if (!init_sentinels_done) {
-      /* Set sentinels and other global variables */
-      giveup_code = 1;            /* no error code initially */
-      nblock = -1;                /* block counter */
-      init_sentinels_done = 1;    /* sentinels have been initialised */
-    }
-    pthread_mutex_unlock(&count_mutex);
+    WAIT_INIT(NULL, context->parent_context);
+
+    if(context->parent_context->end_threads)
+    {
+      break;
+    }
 
     /* Get parameters for this thread before entering the main loop */
-    blocksize = params.blocksize;
-    ebsize = blocksize + params.typesize*(int32_t)sizeof(int32_t);
-    compress = params.compress;
-    flags = params.flags;
-    maxbytes = params.maxbytes;
-    nblocks = params.nblocks;
-    leftover = params.leftover;
-    bstarts = params.bstarts;
-    src = params.src;
-    dest = params.dest;
-    tmp = params.tmp[tid];
-    tmp2 = params.tmp2[tid];
+    blocksize = context->parent_context->blocksize;
+    ebsize = blocksize + context->parent_context->typesize * (int32_t)sizeof(int32_t);
+    compress = context->parent_context->compress;
+    flags = *(context->parent_context->header_flags);
+    maxbytes = context->parent_context->destsize;
+    nblocks = context->parent_context->nblocks;
+    leftover = context->parent_context->leftover;
+    bstarts = context->parent_context->bstarts;
+    src = context->parent_context->src;
+    dest = context->parent_context->dest;
+
+    if (blocksize > context->tmpblocksize)
+    {
+      my_free(context->tmp);
+      context->tmp = my_malloc(blocksize + ebsize + blocksize);
+      context->tmp2 = context->tmp + blocksize;
+      context->tmp3 = context->tmp + blocksize + ebsize;
+    }
+
+    tmp = context->tmp;
+    tmp2 = context->tmp2;
+    tmp3 = context->tmp3;
 
     ntbytes = 0;                /* only useful for decompression */
@@ -1048,8 +1616,8 @@
     if (compress && !(flags & BLOSC_MEMCPYED)) {
       /* Compression always has to follow the block order */
-      pthread_mutex_lock(&count_mutex);
-      nblock++;
-      nblock_ = nblock;
-      pthread_mutex_unlock(&count_mutex);
+      pthread_mutex_lock(&context->parent_context->count_mutex);
+      context->parent_context->thread_nblock++;
+      nblock_ = context->parent_context->thread_nblock;
+      pthread_mutex_unlock(&context->parent_context->count_mutex);
       tblock = nblocks;
     }
@@ -1059,9 +1627,9 @@
 
       /* Blocks per thread */
-      tblocks = nblocks / nthreads;
-      leftover2 = nblocks % nthreads;
+      tblocks = nblocks / context->parent_context->numthreads;
+      leftover2 = nblocks % context->parent_context->numthreads;
       tblocks = (leftover2>0)? tblocks+1: tblocks;
 
-      nblock_ = tid*tblocks;
+      nblock_ = context->tid*tblocks;
       tblock = nblock_ + tblocks;
       if (tblock > nblocks) {
@@ -1072,5 +1640,5 @@
     /* Loop over blocks */
     leftoverblock = 0;
-    while ((nblock_ < tblock) && giveup_code > 0) {
+    while ((nblock_ < tblock) && context->parent_context->thread_giveup_code > 0) {
       bsize = blocksize;
       if (nblock_ == (nblocks - 1) && (leftover > 0)) {
@@ -1087,6 +1655,6 @@
         else {
           /* Regular compression */
-          cbytes = blosc_c(bsize, leftoverblock, 0, ebsize,
-                           src+nblock_*blocksize, tmp2, tmp);
+          cbytes = blosc_c(context->parent_context, bsize, leftoverblock, 0, ebsize,
+                           src+nblock_*blocksize, tmp2, tmp, tmp3);
         }
       }
@@ -1099,6 +1667,7 @@
         }
         else {
-          cbytes = blosc_d(bsize, leftoverblock,
-                           src+sw32(bstarts[nblock_]), dest+nblock_*blocksize,
+          cbytes = blosc_d(context->parent_context, bsize, leftoverblock,
+                           src + sw32_(bstarts + nblock_ * 4),
+                           dest+nblock_*blocksize,
                            tmp, tmp2);
         }
@@ -1106,5 +1675,5 @@
 
       /* Check whether current thread has to giveup */
-      if (giveup_code <= 0) {
+      if (context->parent_context->thread_giveup_code <= 0) {
         break;
       }
@@ -1113,7 +1682,7 @@
       if (cbytes < 0) {            /* compr/decompr failure */
         /* Set giveup_code error */
-        pthread_mutex_lock(&count_mutex);
-        giveup_code = cbytes;
-        pthread_mutex_unlock(&count_mutex);
+        pthread_mutex_lock(&context->parent_context->count_mutex);
+        context->parent_context->thread_giveup_code = cbytes;
+        pthread_mutex_unlock(&context->parent_context->count_mutex);
         break;
       }
@@ -1121,16 +1690,16 @@
       if (compress && !(flags & BLOSC_MEMCPYED)) {
         /* Start critical section */
-        pthread_mutex_lock(&count_mutex);
-        ntdest = params.ntbytes;
-        bstarts[nblock_] = sw32(ntdest);    /* update block start counter */
-        if ( (cbytes == 0) || (ntdest+cbytes > (int32_t)maxbytes) ) {
-          giveup_code = 0;                  /* uncompressible buffer */
-          pthread_mutex_unlock(&count_mutex);
+        pthread_mutex_lock(&context->parent_context->count_mutex);
+        ntdest = context->parent_context->num_output_bytes;
+        _sw32(bstarts + nblock_ * 4, ntdest); /* update block start counter */
+        if ( (cbytes == 0) || (ntdest+cbytes > maxbytes) ) {
+          context->parent_context->thread_giveup_code = 0;  /* uncompressible buffer */
+          pthread_mutex_unlock(&context->parent_context->count_mutex);
           break;
         }
-        nblock++;
-        nblock_ = nblock;
-        params.ntbytes += cbytes;           /* update return bytes counter */
-        pthread_mutex_unlock(&count_mutex);
+        context->parent_context->thread_nblock++;
+        nblock_ = context->parent_context->thread_nblock;
+        context->parent_context->num_output_bytes += cbytes;           /* update return bytes counter */
+        pthread_mutex_unlock(&context->parent_context->count_mutex);
         /* End of critical section */
 
@@ -1147,54 +1716,72 @@
 
     /* Sum up all the bytes decompressed */
-    if ((!compress || (flags & BLOSC_MEMCPYED)) && giveup_code > 0) {
+    if ((!compress || (flags & BLOSC_MEMCPYED)) && context->parent_context->thread_giveup_code > 0) {
       /* Update global counter for all threads (decompression only) */
-      pthread_mutex_lock(&count_mutex);
-      params.ntbytes += ntbytes;
-      pthread_mutex_unlock(&count_mutex);
+      pthread_mutex_lock(&context->parent_context->count_mutex);
+      context->parent_context->num_output_bytes += ntbytes;
+      pthread_mutex_unlock(&context->parent_context->count_mutex);
     }
 
     /* Meeting point for all threads (wait for finalization) */
-    WAIT_FINISH;
-
-  }  /* closes while(1) */
-
-  /* This should never be reached, but anyway */
-  return(0);
-}
-
-
-static int init_threads(void)
+    WAIT_FINISH(NULL, context->parent_context);
+  }
+
+  /* Cleanup our working space and context */
+  my_free(context->tmp);
+  my_free(context);
+
+  return(NULL);
+}
+
+
+static int init_threads(struct blosc_context* context)
 {
   int32_t tid;
   int rc2;
+  int32_t ebsize;
+  struct thread_context* thread_context;
 
   /* Initialize mutex and condition variable objects */
-  pthread_mutex_init(&count_mutex, NULL);
+  pthread_mutex_init(&context->count_mutex, NULL);
+
+  /* Set context thread sentinels */
+  context->thread_giveup_code = 1;
+  context->thread_nblock = -1;
 
   /* Barrier initialization */
 #ifdef _POSIX_BARRIERS_MINE
-  pthread_barrier_init(&barr_init, NULL, nthreads+1);
-  pthread_barrier_init(&barr_finish, NULL, nthreads+1);
+  pthread_barrier_init(&context->barr_init, NULL, context->numthreads+1);
+  pthread_barrier_init(&context->barr_finish, NULL, context->numthreads+1);
 #else
-  pthread_mutex_init(&count_threads_mutex, NULL);
-  pthread_cond_init(&count_threads_cv, NULL);
-  count_threads = 0;      /* Reset threads counter */
+  pthread_mutex_init(&context->count_threads_mutex, NULL);
+  pthread_cond_init(&context->count_threads_cv, NULL);
+  context->count_threads = 0;      /* Reset threads counter */
 #endif
 
 #if !defined(_WIN32)
   /* Initialize and set thread detached attribute */
-  pthread_attr_init(&ct_attr);
-  pthread_attr_setdetachstate(&ct_attr, PTHREAD_CREATE_JOINABLE);
+  pthread_attr_init(&context->ct_attr);
+  pthread_attr_setdetachstate(&context->ct_attr, PTHREAD_CREATE_JOINABLE);
 #endif
 
   /* Finally, create the threads in detached state */
-  for (tid = 0; tid < nthreads; tid++) {
-    tids[tid] = tid;
+  for (tid = 0; tid < context->numthreads; tid++) {
+    context->tids[tid] = tid;
+
+    /* Create a thread context thread owns context (will destroy when finished) */
+    thread_context = (struct thread_context*)my_malloc(sizeof(struct thread_context));
+    thread_context->parent_context = context;
+    thread_context->tid = tid;
+
+    ebsize = context->blocksize + context->typesize * (int32_t)sizeof(int32_t);
+    thread_context->tmp = my_malloc(context->blocksize + ebsize + context->blocksize);
+    thread_context->tmp2 = thread_context->tmp + context->blocksize;
+    thread_context->tmp3 = thread_context->tmp + context->blocksize + ebsize;
+    thread_context->tmpblocksize = context->blocksize;
+
 #if !defined(_WIN32)
-    rc2 = pthread_create(&threads[tid], &ct_attr, (void*)t_blosc,
-			(void *)&tids[tid]);
+    rc2 = pthread_create(&context->threads[tid], &context->ct_attr, t_blosc, (void *)thread_context);
 #else
-    rc2 = pthread_create(&threads[tid], NULL, (void*)t_blosc,
-			(void *)&tids[tid]);
+    rc2 = pthread_create(&context->threads[tid], NULL, t_blosc, (void *)thread_context);
 #endif
     if (rc2) {
@@ -1205,42 +1792,35 @@
   }
 
-  init_threads_done = 1;                 /* Initialization done! */
-  pid = (int)getpid();                   /* save the PID for this process */
 
   return(0);
 }
 
-void blosc_init(void) {
-  /* Init global lock  */
-  pthread_mutex_init(&global_comp_mutex, NULL);
-  init_lib = 1;
-}
-
-int blosc_set_nthreads(int nthreads_new) 
-{
-  int ret;
-
-  /* Check if should initialize (implementing previous 1.2.3 behaviour,
-     where calling blosc_set_nthreads was enough) */
-  if (!init_lib) blosc_init();
-
-  /* Take global lock  */
-  pthread_mutex_lock(&global_comp_mutex);
-  
-  ret = blosc_set_nthreads_(nthreads_new);
-  /* Release global lock  */
-  pthread_mutex_unlock(&global_comp_mutex);
-  
+int blosc_get_nthreads(void)
+{
+  int ret = g_threads;
+
   return ret;
 }
 
-int blosc_set_nthreads_(int nthreads_new)
-{
-  int32_t nthreads_old = nthreads;
-  int32_t t;
-  int rc2;
-  void *status;
-
-  if (nthreads_new > BLOSC_MAX_THREADS) {
+int blosc_set_nthreads(int nthreads_new)
+{
+  int ret = g_threads;
+
+  /* Check if should initialize */
+  if (!g_initlib) blosc_init();
+
+  if (nthreads_new != ret){
+    /* Re-initialize Blosc */
+    blosc_destroy();
+    blosc_init();
+    g_threads = nthreads_new;
+  }
+
+  return ret;
+}
+
+int blosc_set_nthreads_(struct blosc_context* context)
+{
+  if (context->numthreads > BLOSC_MAX_THREADS) {
     fprintf(stderr,
             "Error.  nthreads cannot be larger than BLOSC_MAX_THREADS (%d)",
@@ -1248,168 +1828,280 @@
     return -1;
   }
-  else if (nthreads_new <= 0) {
+  else if (context->numthreads <= 0) {
     fprintf(stderr, "Error.  nthreads must be a positive integer");
     return -1;
   }
 
-  /* Only join threads if they are not initialized or if our PID is
-     different from that in pid var (probably means that we are a
-     subprocess, and thus threads are non-existent). */
-  if (nthreads > 1 && init_threads_done && pid == getpid()) {
-      /* Tell all existing threads to finish */
-      end_threads = 1;
-      /* Synchronization point for all threads (wait for initialization) */
-      WAIT_INIT;
-      /* Join exiting threads */
-      for (t=0; t<nthreads; t++) {
-        rc2 = pthread_join(threads[t], &status);
-        if (rc2) {
-          fprintf(stderr, "ERROR; return code from pthread_join() is %d\n", rc2);
-          fprintf(stderr, "\tError detail: %s\n", strerror(rc2));
-          return(-1);
-        }
-      }
-      init_threads_done = 0;
-      end_threads = 0;
-    }
-
-  /* Launch a new pool of threads (if necessary) */
-  nthreads = nthreads_new;
-  if (nthreads > 1 && (!init_threads_done || pid != getpid())) {
-    init_threads();
-  }
-
-  return nthreads_old;
-}
-
-
-/* Free possible memory temporaries and thread resources */
-int blosc_free_resources(void)
+  /* Launch a new pool of threads */
+  if (context->numthreads > 1 && context->numthreads != context->threads_started) {
+    blosc_release_threadpool(context);
+    init_threads(context);
+  }
+
+  /* We have now started the threads */
+  context->threads_started = context->numthreads;
+
+  return context->numthreads;
+}
+
+char* blosc_get_compressor(void)
+{
+  char* compname;
+  blosc_compcode_to_compname(g_compressor, &compname);
+
+  return compname;
+}
+
+int blosc_set_compressor(const char *compname)
+{
+  int code = blosc_compname_to_compcode(compname);
+
+  g_compressor = code;
+
+  /* Check if should initialize */
+  if (!g_initlib) blosc_init();
+
+  return code;
+}
+
+char* blosc_list_compressors(void)
+{
+  static int compressors_list_done = 0;
+  static char ret[256];
+
+  if (compressors_list_done) return ret;
+  ret[0] = '\0';
+  strcat(ret, BLOSC_BLOSCLZ_COMPNAME);
+#if defined(HAVE_LZ4)
+  strcat(ret, ","); strcat(ret, BLOSC_LZ4_COMPNAME);
+  strcat(ret, ","); strcat(ret, BLOSC_LZ4HC_COMPNAME);
+#endif /* HAVE_LZ4 */
+#if defined(HAVE_SNAPPY)
+  strcat(ret, ","); strcat(ret, BLOSC_SNAPPY_COMPNAME);
+#endif /* HAVE_SNAPPY */
+#if defined(HAVE_ZLIB)
+  strcat(ret, ","); strcat(ret, BLOSC_ZLIB_COMPNAME);
+#endif /* HAVE_ZLIB */
+#if defined(HAVE_ZSTD)
+  strcat(ret, ","); strcat(ret, BLOSC_ZSTD_COMPNAME);
+#endif /* HAVE_ZSTD */
+  compressors_list_done = 1;
+  return ret;
+}
+
+char* blosc_get_version_string(void)
+{
+  static char ret[256];
+  strcpy(ret, BLOSC_VERSION_STRING);
+  return ret;
+}
+
+int blosc_get_complib_info(char *compname, char **complib, char **version)
+{
+  int clibcode;
+  char *clibname;
+  char *clibversion = "unknown";
+
+#if (defined(HAVE_LZ4) && defined(LZ4_VERSION_MAJOR)) || (defined(HAVE_SNAPPY) && defined(SNAPPY_VERSION)) || defined(ZSTD_VERSION_MAJOR)
+  char sbuffer[256];
+#endif
+
+  clibcode = compname_to_clibcode(compname);
+  clibname = clibcode_to_clibname(clibcode);
+
+  /* complib version */
+  if (clibcode == BLOSC_BLOSCLZ_LIB) {
+    clibversion = BLOSCLZ_VERSION_STRING;
+  }
+#if defined(HAVE_LZ4)
+  else if (clibcode == BLOSC_LZ4_LIB) {
+#if defined(LZ4_VERSION_MAJOR)
+    sprintf(sbuffer, "%d.%d.%d",
+            LZ4_VERSION_MAJOR, LZ4_VERSION_MINOR, LZ4_VERSION_RELEASE);
+    clibversion = sbuffer;
+#endif /* LZ4_VERSION_MAJOR */
+  }
+#endif /* HAVE_LZ4 */
+#if defined(HAVE_SNAPPY)
+  else if (clibcode == BLOSC_SNAPPY_LIB) {
+#if defined(SNAPPY_VERSION)
+    sprintf(sbuffer, "%d.%d.%d", SNAPPY_MAJOR, SNAPPY_MINOR, SNAPPY_PATCHLEVEL);
+    clibversion = sbuffer;
+#endif /* SNAPPY_VERSION */
+  }
+#endif /* HAVE_SNAPPY */
+#if defined(HAVE_ZLIB)
+  else if (clibcode == BLOSC_ZLIB_LIB) {
+    clibversion = ZLIB_VERSION;
+  }
+#endif /* HAVE_ZLIB */
+#if defined(HAVE_ZSTD)
+  else if (clibcode == BLOSC_ZSTD_LIB) {
+    sprintf(sbuffer, "%d.%d.%d",
+            ZSTD_VERSION_MAJOR, ZSTD_VERSION_MINOR, ZSTD_VERSION_RELEASE);
+    clibversion = sbuffer;
+  }
+#endif /* HAVE_ZSTD */
+
+  *complib = strdup(clibname);
+  *version = strdup(clibversion);
+  return clibcode;
+}
+
+/* Return `nbytes`, `cbytes` and `blocksize` from a compressed buffer. */
+void blosc_cbuffer_sizes(const void *cbuffer, size_t *nbytes,
+                         size_t *cbytes, size_t *blocksize)
+{
+  uint8_t *_src = (uint8_t *)(cbuffer);    /* current pos for source buffer */
+  uint8_t version, versionlz;              /* versions for compressed header */
+
+  /* Read the version info (could be useful in the future) */
+  version = _src[0];                       /* blosc format version */
+  versionlz = _src[1];                     /* blosclz format version */
+
+  version += 0;                            /* shut up compiler warning */
+  versionlz += 0;                          /* shut up compiler warning */
+
+  /* Read the interesting values */
+  *nbytes = (size_t)sw32_(_src + 4);       /* uncompressed buffer size */
+  *blocksize = (size_t)sw32_(_src + 8);    /* block size */
+  *cbytes = (size_t)sw32_(_src + 12);      /* compressed buffer size */
+}
+
+
+/* Return `typesize` and `flags` from a compressed buffer. */
+void blosc_cbuffer_metainfo(const void *cbuffer, size_t *typesize,
+                            int *flags)
+{
+  uint8_t *_src = (uint8_t *)(cbuffer);  /* current pos for source buffer */
+  uint8_t version, versionlz;            /* versions for compressed header */
+
+  /* Read the version info (could be useful in the future) */
+  version = _src[0];                     /* blosc format version */
+  versionlz = _src[1];                   /* blosclz format version */
+
+  version += 0;                             /* shut up compiler warning */
+  versionlz += 0;                           /* shut up compiler warning */
+
+  /* Read the interesting values */
+  *flags = (int)_src[2];                 /* flags */
+  *typesize = (size_t)_src[3];           /* typesize */
+}
+
+
+/* Return version information from a compressed buffer. */
+void blosc_cbuffer_versions(const void *cbuffer, int *version,
+                            int *versionlz)
+{
+  uint8_t *_src = (uint8_t *)(cbuffer);  /* current pos for source buffer */
+
+  /* Read the version info */
+  *version = (int)_src[0];         /* blosc format version */
+  *versionlz = (int)_src[1];       /* Lempel-Ziv compressor format version */
+}
+
+
+/* Return the compressor library/format used in a compressed buffer. */
+char *blosc_cbuffer_complib(const void *cbuffer)
+{
+  uint8_t *_src = (uint8_t *)(cbuffer);  /* current pos for source buffer */
+  int clibcode;
+  char *complib;
+
+  /* Read the compressor format/library info */
+  clibcode = (_src[2] & 0xe0) >> 5;
+  complib = clibcode_to_clibname(clibcode);
+  return complib;
+}
+
+/* Get the internal blocksize to be used during compression.  0 means
+   that an automatic blocksize is computed internally. */
+int blosc_get_blocksize(void)
+{
+  return (int)g_force_blocksize;
+}
+
+/* Force the use of a specific blocksize.  If 0, an automatic
+   blocksize will be used (the default). */
+void blosc_set_blocksize(size_t size)
+{
+  g_force_blocksize = (int32_t)size;
+}
+
+void blosc_init(void)
+{
+  /* Return if we are already initialized */
+  if (g_initlib) return;
+
+  pthread_mutex_init(&global_comp_mutex, NULL);
+  g_global_context = (struct blosc_context*)my_malloc(sizeof(struct blosc_context));
+  g_global_context->threads_started = 0;
+  g_initlib = 1;
+}
+
+void blosc_destroy(void)
+{
+  /* Return if Blosc is not initialized */
+  if (!g_initlib) return;
+
+  g_initlib = 0;
+  blosc_release_threadpool(g_global_context);
+  my_free(g_global_context);
+  pthread_mutex_destroy(&global_comp_mutex);
+}
+
+int blosc_release_threadpool(struct blosc_context* context)
 {
   int32_t t;
+  void* status;
+  int rc;
   int rc2;
-  void *status;
- 
-   /* Take global lock  */
-  pthread_mutex_lock(&global_comp_mutex);
-
-  /* Release temporaries */
-  if (init_temps_done) {
-    release_temporaries();
-  }
-
-  /* Finish the possible thread pool */
-  if (nthreads > 1 && init_threads_done) {
+
+  if (context->threads_started > 0)
+  {
     /* Tell all existing threads to finish */
-    end_threads = 1;
-    /* Synchronization point for all threads (wait for initialization) */
-    WAIT_INIT;
+    context->end_threads = 1;
+
+    /* Sync threads */
+    WAIT_INIT(-1, context);
+
     /* Join exiting threads */
-    for (t=0; t<nthreads; t++) {
-      rc2 = pthread_join(threads[t], &status);
+    for (t=0; t<context->threads_started; t++) {
+      rc2 = pthread_join(context->threads[t], &status);
       if (rc2) {
         fprintf(stderr, "ERROR; return code from pthread_join() is %d\n", rc2);
         fprintf(stderr, "\tError detail: %s\n", strerror(rc2));
-        return(-1);
       }
     }
 
     /* Release mutex and condition variable objects */
-    pthread_mutex_destroy(&count_mutex);
+    pthread_mutex_destroy(&context->count_mutex);
 
     /* Barriers */
-#ifdef _POSIX_BARRIERS_MINE
-    pthread_barrier_destroy(&barr_init);
-    pthread_barrier_destroy(&barr_finish);
-#else
-    pthread_mutex_destroy(&count_threads_mutex);
-    pthread_cond_destroy(&count_threads_cv);
-#endif
-
-    /* Thread attributes */
-#if !defined(_WIN32)
-    pthread_attr_destroy(&ct_attr);
-#endif
-
-    init_threads_done = 0;
-    end_threads = 0;
-  }
-   /* Release global lock  */
-  pthread_mutex_unlock(&global_comp_mutex);
-  return(0);
-
-}
-
-void blosc_destroy(void) {
-  /* Free the resources */
-  blosc_free_resources();
-  /* Destroy global lock */
-  pthread_mutex_destroy(&global_comp_mutex);
-}
-
-/* Return `nbytes`, `cbytes` and `blocksize` from a compressed buffer. */
-void blosc_cbuffer_sizes(const void *cbuffer, size_t *nbytes,
-                         size_t *cbytes, size_t *blocksize)
-{
-  uint8_t *_src = (uint8_t *)(cbuffer);    /* current pos for source buffer */
-  uint8_t version, versionlz;              /* versions for compressed header */
-
-  /* Read the version info (could be useful in the future) */
-  version = _src[0];                         /* blosc format version */
-  versionlz = _src[1];                       /* blosclz format version */
-
-  version += 0;                             /* shut up compiler warning */
-  versionlz += 0;                           /* shut up compiler warning */
-
-  /* Read the interesting values */
-  _src += 4;
-  *nbytes = (size_t)sw32(((int32_t *)_src)[0]);  /* uncompressed buffer size */
-  *blocksize = (size_t)sw32(((int32_t *)_src)[1]);   /* block size */
-  *cbytes = (size_t)sw32(((int32_t *)_src)[2]);  /* compressed buffer size */
-}
-
-
-/* Return `typesize` and `flags` from a compressed buffer. */
-void blosc_cbuffer_metainfo(const void *cbuffer, size_t *typesize,
-                            int *flags)
-{
-  uint8_t *_src = (uint8_t *)(cbuffer);  /* current pos for source buffer */
-  uint8_t version, versionlz;            /* versions for compressed header */
-
-  /* Read the version info (could be useful in the future) */
-  version = _src[0];                     /* blosc format version */
-  versionlz = _src[1];                   /* blosclz format version */
-
-  version += 0;                             /* shut up compiler warning */
-  versionlz += 0;                           /* shut up compiler warning */
-
-  /* Read the interesting values */
-  *flags = (int)_src[2];                 /* flags */
-  *typesize = (size_t)_src[3];           /* typesize */
-}
-
-
-/* Return version information from a compressed buffer. */
-void blosc_cbuffer_versions(const void *cbuffer, int *version,
-                            int *versionlz)
-{
-  uint8_t *_src = (uint8_t *)(cbuffer);  /* current pos for source buffer */
-
-  /* Read the version info */
-  *version = (int)_src[0];             /* blosc format version */
-  *versionlz = (int)_src[1];           /* blosclz format version */
-}
-
-
-/* Force the use of a specific blocksize.  If 0, an automatic
-   blocksize will be used (the default). */
-void blosc_set_blocksize(size_t size)
-{
-  /* Take global lock  */
-  pthread_mutex_lock(&global_comp_mutex);
-  
-  force_blocksize = (int32_t)size;
-  
-   /* Release global lock  */
-  pthread_mutex_unlock(&global_comp_mutex);
-}
+  #ifdef _POSIX_BARRIERS_MINE
+      pthread_barrier_destroy(&context->barr_init);
+      pthread_barrier_destroy(&context->barr_finish);
+  #else
+      pthread_mutex_destroy(&context->count_threads_mutex);
+      pthread_cond_destroy(&context->count_threads_cv);
+  #endif
+
+      /* Thread attributes */
+  #if !defined(_WIN32)
+      pthread_attr_destroy(&context->ct_attr);
+  #endif
+
+  }
+
+  context->threads_started = 0;
+
+  return 0;
+}
+
+int blosc_free_resources(void)
+{
+  /* Return if Blosc is not initialized */
+  if (!g_initlib) return -1;
+
+  return blosc_release_threadpool(g_global_context);
+}
